﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Collections.ObjectModel;

namespace WebApplication1
{
    public partial class Default : System.Web.UI.Page
    {
        private readonly string[] markerIcons = new string[] { "marker_blue.gif", "marker.gif", "marker_gold.gif", "marker_green.gif" };
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("MarkerOverlay");
                markerOverlay.Features.Add("Kansas", new Feature(-94.48242, 38.75977));
                markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("../../theme/default/img/marker_blue.gif", 21, 25);
                markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                markerOverlay.Click += new EventHandler<MarkerOverlayClickEventArgs>(markerOverlay_Click);
                Map1.CustomOverlays.Add(markerOverlay);
            }
        }

        void markerOverlay_Click(object sender, MarkerOverlayClickEventArgs e)
        {
            if (!Map1.Popups.Contains("samplePopup"))
            {
                InMemoryMarkerOverlay markerOverlay = (InMemoryMarkerOverlay)Map1.CustomOverlays["MarkerOverlay"];
                Collection<Marker> markers = markerOverlay.GetMarkers(Map1.CurrentExtent, 1);
                string customerString = String.Format("<div>{0}<br/>{1}</div>", markers[0].Id, markers[0].Position.GetWellKnownText());
                CloudPopup popup = new CloudPopup("samplePopup", markers[0].Position, customerString, 400, 200);
                popup.AutoSize = true;
                popup.AutoPan = true;
                popup.HasCloseButton = true;
                Map1.Popups.Add(popup);
            }
            else
            {
                Map1.Popups["samplePopup"].IsVisible = true;
            }
        }

    }
}